#ifndef CLIENTLINK_HPP
#define CLIENTLINK_HPP

#include "Server.h"
#include "World.h"
#include "MasterMPI.h"
#include "Box.h"
#include "Cylinder.h"

class ClientLink {
	
	public:

		int DEBUG;
		Server *mysocket;	
		World *world;		// we keep a pointer to the master's world
		MasterMPI *mpi;		// we also need to communicate with our MPI object

		int num_p;		// how many nodes in our MPI world

		ClientLink(int num_p, int port, int dataport, int debug, 
				World *w, MasterMPI *m);
		void connectInit();
		void recvParams();
		void recvWorld();
		void recvNetwork();
		void recvAll();		// call the above three recv functions
		void bye();
		void shutdown();
		int getCommand();
		void sendStats(double results[], char hostname[MAX_NODE][80]);
		void sendFrame();
		void sendClientFrame();
		void simDone();
};

#endif
