// This class handles all the functionality that the master has

#ifndef MASTER_HPP
#define MASTER_HPP

#include "ClientLink.h"
#include "World.h"
#include "MasterMPI.h"
#include "Timer.h"

#include "Shape.h"
#include "Box.h"
#include "Cylinder.h"

class Master {
	int DEBUG;			// shall we print debugging info?
	ClientLink *client_link;	// respsonbile for the socket communication with the client
	World *world;			// master has a world object
	MasterMPI *mpi_link;		// responsible for MPI communication with slaves

	public:
		Master(int num_p, int port, int dataport, int debug);
		void connectInit();
		void loop();
};

#endif
