// This class handles MPI communications between the master and the slaves

#ifndef MASTERMPI_HPP
#define MASTERMPI_HPP

#include "World.h"
#include "msgtags.h"

#define MAX_NODE 128

class MasterMPI {

	public:

	int DEBUG;		// should we print debugging output?
	int num_p;		// how many processors in our MPI world
	int num_p_compute;	// how many processors will be computing (usually = to num_p, except if we have too many processors for the number of rows)
	World *world;		// we keep a pointer to the master's world

	MasterMPI(int num_p, int debug, World *w);

	void runStats(double result[], char hostname[MAX_NODE][80]);	// obtain a performance number and system name from all slaves
	void sendCommand(int command);		// send a command to all the slaves
	void initSlaves();			// get the slaves ready to run a simulation
	int recvUpdate();			// recv an update from all the slaves, return 1 if normal step, 0 if time to shutdown

	int updateTag;
};

#endif
