#include "Particle.h"

//******************************************************************
// Default constructor.
//******************************************************************
Particle::Particle() : pos(0,0), vel(0,0), mass(0), deleted(1) {}

//******************************************************************
// Constructor.
//******************************************************************
Particle::Particle(Point p, Point v, double m) : 
pos(p), vel(v), mass(m), deleted(1) {}


//******************************************************************
// Copy constructor
//******************************************************************
Particle::Particle(const Particle & P)
{
	pos = P.getPosition(); 
	vel = P.getVelocity();
	mass = P.getMass();
	deleted = P.deleted;
}

//******************************************************************
// overloaded "=" operator
//******************************************************************
Particle & Particle::operator = (const Particle & P)
{
	// A check to make sure we're not trying to copy ourself to
	// ourself. If this did happen, then we would delete all
	// information before we had a chance to copy it.
	if(this == &P)
		return *this;
		
	pos = P.getPosition();
	vel = P.getVelocity();
	mass = P.getMass();
	deleted = P.deleted;

	return (*this);
}

//******************************************************************
//  overloaded ostream operator (standard output)
//******************************************************************
ostream & operator << ( ostream & str, const Particle & p)
{
	str << "mass = " << p.mass  
	    << " pos = " << p.pos <<" vel = " << p.vel << " del = " 
		<< p.deleted << endl;

	return str;
}	


//******************************************************************
// overloaded ofstream operator (file output)
//******************************************************************
ofstream & operator << ( ofstream & fStr, const Particle & p)
{
	fStr << p.pos;
	return fStr;
}	



