//***********************************************************
//
// Used to store varibles that are represented in two 
// dimensions; such as position and velocity.
//
// Written by: Brian Schlatter
// Last updated: 6/12/1999
//
//********************************************************** 
#ifndef POINT_HPP
#define POINT_HPP

#include <iostream.h>
#include <fstream.h>

class Point {
	public:
		Point(): x(0), y(0) {}
		Point(double new_x, double new_y) : x(new_x), y(new_y) {}
		Point(const Point &P) {x = P.x; y = P.y; }
		
		void setXY(double new_x, double new_y) {x=new_x; y=new_y;}
		void setX(double new_x) 			   {x = new_x; }
		void setY(double new_y) 			   {y = new_y; }
		double getX() const     		       { return x; }
		double getY() const    				   { return y; }


		Point & operator = (const Point & P);	
		friend ostream & operator << (ostream & str, const Point &);
		friend ofstream & operator << (ofstream & fStr, const Point &);

	private:
		 double x, y;
};

#endif
