
// Simple class to handle reading and writing of project files

// A project file consists of just the three filenames of the
// parameters, world, and network settings 


import java.io.*;
import java.awt.*;

public class Project 
{    
    public String param_filename = new String();
    public String world_filename = new String();
    public String network_filename = new String();
    
    private sphclient myparent;
    
    // this class also handles looking up the previous three project files
    public String last_file1 = new String();
    public String last_file2 = new String();
    public String last_file3 = new String();
    
    public Project(Frame parent)
    {
        // see if there is a last project file file in this directory
        
        myparent = (sphclient) parent;
        
        read_last_files();        
    }
 
    public boolean read_last_files()
    {
               String temp;
        
        DataInputStream input;
        
        try {
              input = new DataInputStream(new FileInputStream("sphlast"));
        } 
        catch (IOException e)
            {
                // probably means it didn't exist                
                return false;
            }
        try {
            last_file1 = input.readUTF();
            last_file2 = input.readUTF();
            last_file3 = input.readUTF();            
        }
        catch (Exception e)
        {
            System.out.println("Error reading data from sphlast");
            return false;
        }        

        try {
            input.close();
        }
        catch (IOException e)
        {
            System.out.println("Error closing sphlast");
            return false;        
        }                
        return true;
    }

    public boolean write_last_files()
    {
        DataOutputStream output;
        
        try {
              output = new DataOutputStream(new FileOutputStream("sphlast"));
        } 
        catch (IOException e)
            {
                System.out.println("Error writing sphlast");
                return false;
            }
        try {
            output.writeUTF(last_file1);
            output.writeUTF(last_file2);
            output.writeUTF(last_file3);        
        }
        catch (IOException e)
        {
            System.out.println("Error writing data to sphlast");
            return false;
        }        

        try {
            output.close();
        }
        catch (IOException e)
        {
            System.out.println("Error closing sphlast");
            return false;        
        }       
        return true; 
    }
    
    public boolean read_file(String filename)
    {
        String temp;
        
        DataInputStream input;
        
        try {
              input = new DataInputStream(new FileInputStream(filename));
        } 
        catch (IOException e)
            {
                System.out.println("Error opening "+filename);
                return false;
            }
        try {
            param_filename = input.readUTF();
            world_filename = input.readUTF();
            network_filename = input.readUTF();            
        }
        catch (Exception e)
        {
            System.out.println("Error reading data from "+filename);
            return false;
        }        

        try {
            input.close();
        }
        catch (IOException e)
        {
            System.out.println("Error closing "+filename);
            return false;        
        }
                
        // put this new file into our quick menu options strings
        
        if (!(last_file1.equals(filename)))
        {
            last_file3 = last_file2;
            last_file2 = last_file1;
            last_file1 = filename;
            
            myparent.update_menus();
        }
        
        return true;        
    }
    
    public boolean write_file(String filename)
    {
        DataOutputStream output;
        
        try {
              output = new DataOutputStream(new FileOutputStream(filename));
        } 
        catch (IOException e)
            {
                System.out.println("Error writing "+filename);
                return false;
            }
        try {
            output.writeUTF(param_filename);
            output.writeUTF(world_filename);
            output.writeUTF(network_filename);        
        }
        catch (IOException e)
        {
            System.out.println("Error writing data to "+filename);
            return false;
        }        

        try {
            output.close();
        }
        catch (IOException e)
        {
            System.out.println("Error closing "+filename);
            return false;        
        }       
        // put this new file into our quick menu options strings
        
        if (!(last_file1.equals(filename)))
        {
            last_file3 = last_file2;
            last_file2 = last_file1;
            last_file1 = filename;

            myparent.update_menus();
        }

        return true; 
    }
    
    void load_project(String filename)
    {
            read_file(filename);
            
            // now load the three parameter files if filenames
            // were obtained from the project file
            if (param_filename.length()>0)
                myparent.param.read_file(param_filename);
            if (param_filename.length()>0)
                myparent.world.read_file(world_filename);
            if (param_filename.length()>0)
                myparent.network.read_file(network_filename);
    }
}