// Simple test of the Java client class

// Keith Vertanen 4/99

import java.io.*;
import java.net.*;
import Client;


public class java_client_test {

   static int SIZE = 10;		// how many items in each packet
   static int NUM_PACKS = 3;		// how many repetitions to do

   public static void main( String args[] ) throws IOException
   {
	int port = 5010;
	int dataport = 5011;
	int rev = 1;

	if (args.length<1)
	{
		System.out.println("Not enough command line arguments!");
		System.out.println("     java_client_test system-name (port) (dataport) (reversed bytes)");
		System.out.println("");
	}
	else
	{
		if (args.length>3)
		{
			port = (new Integer(args[1])).intValue();
			dataport = (new Integer(args[2])).intValue();
			rev = (new Integer(args[3])).intValue();
		}


		Client myclient = new Client(port, dataport, args[0],rev);
	
		double C[];
		byte D[];

		C = new double[SIZE];
		D = new byte[SIZE];

		for (int i=0; i<SIZE; i++)
		{
			C[i] = i*i + 0.5;
			D[i] = (byte) i;
		}


		for (int i=0; i<NUM_PACKS; i++)
		{
			myclient.recv_bytes(D, SIZE);
			myclient.send_doubles(C, SIZE);
		}

		myclient.closesocket();	
	
	}
   }
}
